HISTORY_ID = 'tabular_filter'

$ ->
  $(document).on 'change focusout', 'tr#filters .filter', filterChanged
  $(document).on 'click', 'tr#filters .clear_tabular_filters', clearFilters

filterChanged = ->
  refreshTable($(this).parents('table'))

clearFilters = (e) ->
  e.preventDefault()
  table = $(this).closest('table')
  table.find('tr#filters .filter').val('')
  refreshTable(table)

refreshTable = (table) ->
  path = new CurrentPath(table.closest('.popup_window').attr('data-path')).remove_param('tf').remove_param('page').get_path()
  $.ajax path,
    data: filtersHash(table),
    asynchronous: true
    evalScripts: true
    method: "get"
    success: (data, textStatus, jqXHR) ->
      tableBody = $(data).find('tbody').html()
      paginate = $(data).find('.refresh_pagination').html()
      refreshData(table, tableBody, paginate)
      if table.closest('.popup_window').length
        table.closest('.popup_window').attr('data-path', this.url)
      else
        history.pushState({id: HISTORY_ID, tbody: tableBody, paginate: paginate, filters: filtersHistory()}, null, this.url);

$(window).on 'popstate', () ->
  if history.state && history.state.id == HISTORY_ID
    refreshData(filteredTable(), history.state.tbody, history.state.paginate)
    i = 0
    $('table thead tr#filters .filter').each ->
      $(this).val(history.state.filters[i++])

filteredTable = (data = 'body') ->
  $(data).find('table thead tr#filters').closest('table')

filtersHash = (table) ->
  filters = {}
  filtersRow = table.find('tr#filters')
  filtersRow.find('.filter').each () ->
    value = $(this).val()
    mode = ''
    if value
      if $(this).hasClass("date_picker")
        mode = 'd'
      else if $(this).hasClass("boolean")
        mode = 'b'
      filters["tf#{mode}_#{$(this).attr('id')}"] = value
  filters


refreshData = (table, tbody, paginate) ->
  table.find('tbody').html(tbody);
  $('.refresh_pagination').html(paginate)
#$(window).resize(); #!!!special for med with its fixed tables!!!

filtersHistory = ->
  filters = []
  $('table thead tr#filters .filter').each ->
    filters.push($(this).val())
  filters